import java.applet.Applet;
import java.awt.*;
import java.awt.event.*;
import java.applet.*;
import java.awt.geom.*;
import java.math.*;


public class ControlCanvas extends ScaleCanvas implements KeyListener,MouseListener,MouseMotionListener {
    Manager M;
    SelectInteger S;
    Lever FIT,COL,EVE,CHO;
    HSlider[][] NAV=new HSlider[2][8];
    ListenSquare GO,STOP;
    int SELECT;
    Animator A;
    Lever SPEED,THICK;

     public ControlCanvas() {
	 addMouseListener(this);
	 addMouseMotionListener(this);	
         addKeyListener(this);
	 S=new SelectInteger(780,5,40,20,3,2,8,1); //dimension
	 FIT=new Lever(520,20,1,2);
	 COL=new Lever(580,20,0,2);
	 EVE=new Lever(640,20,1,2);
	 CHO=new Lever(700,20,0,3);
	 SELECT=0;
	 GO=new ListenSquare(5,5,40,20,null); GO.on=1;
	 STOP=new ListenSquare(55,5,40,20,null); STOP.on=1;
	 SPEED=new Lever(115,20,8,15);
	 THICK=new Lever(320,20,3,15);

	 Color[] col={new Color(0,0,150),Color.white,Color.yellow};
	 for(int j=0;j<2;++j) {
	   for(int i=0;i<8;++i) {
               NAV[j][i]=new HSlider(0+450*j,80+20*i,400,18,200+450*j,col,"");
	   }
	 }
	 NAV[0][0].pos=300;
	 NAV[1][1].pos=750;
	 A=new Animator();
     }



   public void paint(Graphics g2) {
      Graphics2D g=(Graphics2D) g2;
      g.setRenderingHint(RenderingHints.KEY_ANTIALIASING,RenderingHints.VALUE_ANTIALIAS_ON);
      drawBG(g);
      drawControls(g);
   }

    public void drawBG(Graphics2D g) {
      g.setColor(new Color(0,0,100));
      g.fillRect(0,0,getWidth(),getHeight()); 

    }

    public void drawControls(Graphics2D g) { 
       g.setFont(new Font("Helvetica",Font.PLAIN,14));
       S.render(g,Color.blue,Color.white,Color.yellow);
       FIT.render(g,"aut fit?",Color.blue);
       COL.render(g,"white/col",Color.blue);
       EVE.render(g,"even",Color.blue);
       CHO.render(g,"proj/slice",Color.blue);
       GO.render(g,new Color(0,180,0),"go");
       STOP.render(g,Color.red,"stop");
       SPEED.render(g,"animation speed",Color.blue);
       THICK.render(g,"line thickness",Color.blue);

       for(int i=0;i<2;++i) {
	   for(int j=0;j<S.val;++j) {
	       NAV[i][j].render(g);
	   }
       }
    }

    public void doRun() {
	if(A.HALT==true) {
	    A=new Animator(this.M);
	    new Thread(A).start();
	}
    }

    public void doStop() {
	A.HALT=true;
    }

    public void toggleLevers(Point X) {
	FIT.process(X);
	COL.process(X);
	EVE.process(X);
	CHO.process(X);
	for(int i=0;i<2;++i) {
	    for(int j=0;j<8;++j) {
		NAV[i][j].modify(X);
	    }
	}
    }


    public void tryEven() {
	if(S.val%2==1) return;
	if(EVE.val==0) return;
	int d=S.val/2;
	for(int i=0;i<d;++i) {
	    double x=NAV[0][2*i+0].getValue();
	    double y=NAV[0][2*i+1].getValue();
	    NAV[1][2*i+0].forceValue(y);
	    NAV[1][2*i+1].forceValue(-x);
	}
    }
    
    public void mouseClicked(MouseEvent e) {
        MouseData J=MouseData.process(e);
	toggleLevers(J.X);
	if(GO.inside(J.X)==1) doRun();
	if(STOP.inside(J.X)==1) doStop();
	SPEED.process(J.X);
	THICK.process(J.X);
	tryEven();
	S.modify(J.X);
	repaint();
	M.P.repaint();
    }

    public void mousePressed(MouseEvent e) {
        MouseData J=MouseData.process(e);
	repaint();
    }

     public void mouseReleased(MouseEvent e) {}
     public void mouseEntered(MouseEvent e) {}
     public void mouseExited(MouseEvent e) {}   
     public void mouseMoved(MouseEvent e) {
     }   

     public void mouseDragged(MouseEvent e) {
        MouseData J=MouseData.process(e);
	toggleLevers(J.X);
	tryEven();
	repaint();
	M.P.repaint();
     } 


     public void keyPressed(KeyEvent e) {}
     public void keyReleased(KeyEvent e) {}
     public void keyTyped(KeyEvent e) {	
     }

}

